/* $Id: load.h,v 1.3 2005/10/18 16:25:12 mis Exp $ */
#ifndef PKGDIR_METADATA_LOAD_H
#define PKGDIR_METADATA_LOAD_H


void metadata_loadmod_init(void);
void metadata_loadmod_destroy(void);

struct vfile;

struct repomd_ent {
    char type[32];
    char checksum[64];
    char checksum_type[8];
    time_t ts;
    struct vfile *vf;
    char location[0];
};

/* name => repomd_ent */
tn_hash *metadata_load_repomd(const char *path);
tn_array *metadata_load_primary(struct pkgdir *pkgdir, const char *path);



#endif
